local Cryolysis2 = Cryolysis2
local L = AceLibrary("AceLocale-2.2"):new("Cryolysis2")
local BS = AceLibrary("Babble-Spell-2.2")
local BZ = AceLibrary("Babble-Zone-2.2")

------------------------------------------------------------------------------------------------------
-- Construct the various tooltips for buttons
------------------------------------------------------------------------------------------------------
function Cryolysis2:BuildTooltip(frame, button, anchor)

	if Cryolysis2.db.profile.HideTooltips then
		return
	end

	GameTooltip:SetOwner(frame, anchor)

	if button == "MS" then
		GameTooltip:SetText("Cryolysis 2", 1, 1, 1, 1)
		if Cryolysis2.Private.HighestFoodOnHand == 0 then
			GameTooltip:AddLine(L["Conjured Food"]..": ".."0")
		else
			GameTooltip:AddLine(L["Conjured Food"]..": "..GetItemCount(Cryolysis2.Private.FoodName[Cryolysis2.Private.HighestFoodOnHand]))
		end
		if Cryolysis2.Private.HighestWaterOnHand == 0 then
			GameTooltip:AddLine(L["Conjured Water"]..": ".."0")
		else
			GameTooltip:AddLine(L["Conjured Water"]..": "..GetItemCount(Cryolysis2.Private.WaterName[Cryolysis2.Private.HighestWaterOnHand]))
		end
		GameTooltip:AddLine(select(1,GetItemInfo("Arcane Powder"))..": "..GetItemCount(select(1,GetItemInfo("Arcane Powder"))))
		GameTooltip:AddLine(L["Light Feathers"]..": "..GetItemCount(select(1,GetItemInfo("Light Feather"))))
		GameTooltip:AddLine(L["Teleport Runes"]..": "..GetItemCount(select(1,GetItemInfo("Rune of Teleportation"))))
		GameTooltip:AddLine(L["Portal Runes"]..": "..GetItemCount(select(1,GetItemInfo("Rune of Portals"))))
	end
	if button == "food" then
		GameTooltip:SetText(L["Food"], 1, 1, 1, 1)
		GameTooltip:AddLine(L["Left-click to use."])
		GameTooltip:AddLine(L["Middle-click to trade."])
		GameTooltip:AddLine(L["Right-click to conjure."])
		if Cryolysis2.Private.HasRitual then
			GameTooltip:AddLine(L["Shift + right-click for Ritual of Refreshment."])
		end
	end
	if button == "water" then
		GameTooltip:SetText(L["Water"], 1, 1, 1, 1)
		GameTooltip:AddLine(L["Left-click to use."])
		GameTooltip:AddLine(L["Middle-click to trade."])
		GameTooltip:AddLine(L["Right-click to conjure."])
		if Cryolysis2.Private.HasRitual then
			GameTooltip:AddLine(L["Shift + right-click for Ritual of Refreshment."])
		end
	end
	if button == "gem" then
		GameTooltip:SetText(L["Mana Gem"], 1, 1, 1, 1)
		GameTooltip:AddLine(L["Left-click to use."])
		GameTooltip:AddLine(L["Middle-click for gem menu."])
		GameTooltip:AddLine(L["Right-click to conjure."])
		GameTooltip:AddLine(L["(Outside combat only)"])
		GameTooltip:AddLine(" ")
		for i = #(Cryolysis2.Private.CanConjureGem), 1, -1 do
			if Cryolysis2.Private.HasManaGem[i] == true then
				GameTooltip:AddLine(Cryolysis2.Private.ManaGemName[i]..": "..L["Ready"])
			else
				GameTooltip:AddLine(Cryolysis2.Private.ManaGemName[i]..": "..L["Unavailable"])
			end
		end
	end
	if button == "mount" then
		GameTooltip:SetText(L["Mount"], 1, 1, 1, 1)
		if not Cryolysis2.Private.HasMount then
			GameTooltip:AddLine(L["Click to hearth to "]..GetBindLocation())
		end
		if Cryolysis2.Private.HasMount then
			GameTooltip:AddLine(L["Left-click to use "]..Cryolysis2.db.profile.LeftMount)
			GameTooltip:AddLine(L["Middle-click to hearth to "]..GetBindLocation())
			GameTooltip:AddLine(L["Right-click to use "]..Cryolysis2.db.profile.RightMount)
		end
	end
	if button == "left" then
		GameTooltip:SetText(L["Left Custom Button"], 1, 1, 1, 1)
		if Cryolysis2.db.profile.LeftSpellLeft ~= nil and Cryolysis2.db.profile.LeftSpellLeft ~= ""  then
			GameTooltip:AddLine(L["Left-click to cast "]..Cryolysis2.db.profile.LeftSpellLeft..".")
		end
		if Cryolysis2.db.profile.LeftSpellMid ~= nil and Cryolysis2.db.profile.LeftSpellMid ~= ""  then
			GameTooltip:AddLine(L["Middle-click to cast "]..Cryolysis2.db.profile.LeftSpellMid..".")
		end
		if Cryolysis2.db.profile.LeftSpellRight ~= nil and Cryolysis2.db.profile.LeftSpellRight ~= ""  then
			GameTooltip:AddLine(L["Right-click to cast "]..Cryolysis2.db.profile.LeftSpellRight..".")
		end
		
		if Cryolysis2.db.profile.LeftSpellLeft == nil and Cryolysis2.db.profile.LeftSpellRight == nil and Cryolysis2.db.profile.LeftSpellMid == nil then
			GameTooltip:AddLine(L["No spells assigned to this button."])
			GameTooltip:AddLine(L["You can assign a spell to this button using the Cryolysis 2 menu."])
		end
	end
	if button == "right" then
		GameTooltip:SetText(L["Right Custom Button"], 1, 1, 1, 1)
		if Cryolysis2.db.profile.RightSpellLeft ~= nil and Cryolysis2.db.profile.RightSpellLeft ~= "" then
			GameTooltip:AddLine(L["Left-click to cast "]..Cryolysis2.db.profile.RightSpellLeft..".")
		end
		if Cryolysis2.db.profile.RightSpellMid ~= nil and Cryolysis2.db.profile.RightSpellMid ~= "" then
			GameTooltip:AddLine(L["Middle-click to cast "]..Cryolysis2.db.profile.RightSpellMid..".")
		end
		if Cryolysis2.db.profile.RightSpellRight ~= nil and Cryolysis2.db.profile.RightSpellRight ~= "" then
			GameTooltip:AddLine(L["Right-click to cast "]..Cryolysis2.db.profile.RightSpellRight..".")
		end
		
		if Cryolysis2.db.profile.RightSpellLeft == nil and Cryolysis2.db.profile.RightSpellRight == nil and Cryolysis2.db.profile.RightSpellMid == nil then
			GameTooltip:AddLine(L["No spells assigned to this button."])
			GameTooltip:AddLine(L["You can assign a spell to this button using the Cryolysis 2 menu."])
		end
	end
	if button == "bottom" then
		GameTooltip:SetText(L["Bottom Custom Button"], 1, 1, 1, 1)
		if Cryolysis2.db.profile.BottomSpellLeft ~= nil and Cryolysis2.db.profile.BottomSpellLeft ~= "" then
			GameTooltip:AddLine(L["Left-click to cast "]..Cryolysis2.db.profile.BottomSpellLeft..".")
		end
		if Cryolysis2.db.profile.BottomSpellMid ~= nil and Cryolysis2.db.profile.BottomSpellMid ~= "" then
			GameTooltip:AddLine(L["Middle-click to cast "]..Cryolysis2.db.profile.BottomSpellMid..".")
		end
		if Cryolysis2.db.profile.BottomSpellRight ~= nil and Cryolysis2.db.profile.RightSpellRight ~= "" then
			GameTooltip:AddLine(L["Right-click to cast "]..Cryolysis2.db.profile.BottomSpellRight..".")
		end
		
		if Cryolysis2.db.profile.BottomSpellLeft == nil and Cryolysis2.db.profile.BottomSpellRight == nil and Cryolysis2.db.profile.BottomSpellMid == nil then
			GameTooltip:AddLine(L["No spells assigned to this button."])
			GameTooltip:AddLine(L["You can assign a spell to this button using the Cryolysis 2 menu."])
		end
	end
	if button == "port" then
		GameTooltip:SetText(L["Teleport and Portal Menu"], 1, 1, 1, 1)
		GameTooltip:AddLine(L["Click to open the menu."])
	end
	if button == "buff" then
		GameTooltip:SetText(L["Buff Menu"], 1, 1, 1, 1)
		GameTooltip:AddLine(L["Click to open the menu."])
	end
	if button == "evoc" then
		GameTooltip:SetText(BS["Evocation"], 1, 1, 1, 1)
		GameTooltip:AddLine(L["Click to cast "]..BS["Evocation"]..".")
	end
	if button == "port1" then
		if Cryolysis2.Private.englishFaction == "Alliance" then
			GameTooltip:SetText(BZ["Ironforge"], 1, 1, 1, 1)
			GameTooltip:AddLine(L["Left-click to teleport to "]..BZ["Ironforge"]..".")
			GameTooltip:AddLine(L["Right-click to open a portal to "]..BZ["Ironforge"]..".")
		end
		if Cryolysis2.Private.englishFaction == "Horde" then
			GameTooltip:SetText(BZ["Orgrimmar"], 1, 1, 1, 1)
			GameTooltip:AddLine(L["Left-click to teleport to "]..BZ["Orgrimmar"]..".")
			GameTooltip:AddLine(L["Right-click to open a portal to "]..BZ["Orgrimmar"]..".")
		end
		GameTooltip:AddLine(select(1,GetItemInfo("Teleport Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Teleportation"))).."   "..select(1,GetItemInfo("Portal Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Portals"))))
	end
	if button == "port2" then
		if Cryolysis2.Private.englishFaction == "Alliance" then
			GameTooltip:SetText(BZ["Stormwind City"], 1, 1, 1, 1)
			GameTooltip:AddLine(L["Left-click to teleport to "]..BZ["Stormwind City"]..".")
			GameTooltip:AddLine(L["Right-click to open a portal to "]..BZ["Stormwind City"]..".")
		end
		if Cryolysis2.Private.englishFaction == "Horde" then
			GameTooltip:SetText(BZ["Undercity"], 1, 1, 1, 1)
			GameTooltip:AddLine(L["Left-click to teleport to "]..BZ["Undercity"]..".")
			GameTooltip:AddLine(L["Right-click to open a portal to "]..BZ["Undercity"]..".")
		end
		GameTooltip:AddLine(select(1,GetItemInfo("Teleport Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Teleportation"))).."   "..select(1,GetItemInfo("Portal Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Portals"))))	
    end
	if button == "port3" then
		if Cryolysis2.Private.englishFaction == "Alliance" then
			GameTooltip:SetText(BZ["Darnassus"], 1, 1, 1, 1)
			GameTooltip:AddLine(L["Left-click to teleport to "]..BZ["Darnassus"]..".")
			GameTooltip:AddLine(L["Right-click to open a portal to "]..BZ["Darnassus"]..".")
		end
		if Cryolysis2.Private.englishFaction == "Horde" then
			GameTooltip:SetText(BZ["Thunder Bluff"], 1, 1, 1, 1)
			GameTooltip:AddLine(L["Left-click to teleport to "]..BZ["Thunder Bluff"]..".")
			GameTooltip:AddLine(L["Right-click to open a portal to "]..BZ["Thunder Bluff"]..".")
		end
		GameTooltip:AddLine(select(1,GetItemInfo("Teleport Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Teleportation"))).."   "..select(1,GetItemInfo("Portal Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Portals"))))
	end
	if button == "port4" then
		if Cryolysis2.Private.englishFaction == "Alliance" then
			GameTooltip:SetText(BZ["The Exodar"], 1, 1, 1, 1)
			GameTooltip:AddLine(L["Left-click to teleport to "]..BZ["The Exodar"]..".")
			GameTooltip:AddLine(L["Right-click to open a portal to "]..BZ["The Exodar"]..".")
		end
		if Cryolysis2.Private.englishFaction == "Horde" then
			GameTooltip:SetText(BZ["Silvermoon City"], 1, 1, 1, 1)
			GameTooltip:AddLine(L["Left-click to teleport to "]..BZ["Silvermoon City"]..".")
			GameTooltip:AddLine(L["Right-click to open a portal to "]..BZ["Silvermoon City"]..".")
		end
		GameTooltip:AddLine(select(1,GetItemInfo("Teleport Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Teleportation"))).."   "..select(1,GetItemInfo("Portal Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Portals"))))
	end
	if button == "port5" then
		GameTooltip:SetText(BZ["Shattrath City"], 1, 1, 1, 1)
        GameTooltip:AddLine(L["Left-click to teleport to "]..BZ["Shattrath City"]..".")
        GameTooltip:AddLine(L["Right-click to open a portal to "]..BZ["Shattrath City"]..".")
		GameTooltip:AddLine(select(1,GetItemInfo("Teleport Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Teleportation"))).."   "..select(1,GetItemInfo("Portal Runes"))..": "..GetItemCount(select(1,GetItemInfo("Rune of Portals"))))
	end
	if button == "gem1" then
		GameTooltip:SetText(Cryolysis2.Private.ManaGemName[1], 1, 1, 1, 1)
		if Cryolysis2.Private.HasManaGem[1] then
			GameTooltip:AddLine(L["Conjured"])
			GameTooltip:AddLine(L["Left-click to use "]..Cryolysis2.Private.ManaGemName[1]..".")
		else
			GameTooltip:AddLine(L["Not Conjured"])
			GameTooltip:AddLine(L["Right-click to conjure "]..Cryolysis2.Private.ManaGemName[1]..".")
		end
	end
	if button == "gem2" then
		GameTooltip:SetText(Cryolysis2.Private.ManaGemName[2], 1, 1, 1, 1)
		if Cryolysis2.Private.HasManaGem[2] then
			GameTooltip:AddLine(L["Conjured"])
			GameTooltip:AddLine(L["Left-click to use "]..Cryolysis2.Private.ManaGemName[2]..".")
		else
			GameTooltip:AddLine(L["Not Conjured"])
			GameTooltip:AddLine(L["Right-click to conjure "]..Cryolysis2.Private.ManaGemName[2]..".")
		end
	end
	if button == "gem3" then
		GameTooltip:SetText(Cryolysis2.Private.ManaGemName[3], 1, 1, 1, 1)
		if Cryolysis2.Private.HasManaGem[3] then
			GameTooltip:AddLine(L["Conjured"])
			GameTooltip:AddLine(L["Left-click to use "]..Cryolysis2.Private.ManaGemName[3]..".")
		else
			GameTooltip:AddLine(L["Not Conjured"])
			GameTooltip:AddLine(L["Right-click to conjure "]..Cryolysis2.Private.ManaGemName[3]..".")
		end
	end
	if button == "gem4" then
		GameTooltip:SetText(Cryolysis2.Private.ManaGemName[4], 1, 1, 1, 1)
		if Cryolysis2.Private.HasManaGem[4] then
			GameTooltip:AddLine(L["Conjured"])
			GameTooltip:AddLine(L["Left-click to use "]..Cryolysis2.Private.ManaGemName[4]..".")
		else
			GameTooltip:AddLine(L["Not Conjured"])
			GameTooltip:AddLine(L["Right-click to conjure "]..Cryolysis2.Private.ManaGemName[4]..".")
		end
	end
	if button == "gem5" then
		GameTooltip:SetText(Cryolysis2.Private.ManaGemName[5], 1, 1, 1, 1)
		if Cryolysis2.Private.HasManaGem[5] then
			GameTooltip:AddLine(L["Conjured"])
			GameTooltip:AddLine(L["Left-click to use "]..Cryolysis2.Private.ManaGemName[5]..".")
		else
			GameTooltip:AddLine(L["Not Conjured"])
			GameTooltip:AddLine(L["Right-click to conjure "]..Cryolysis2.Private.ManaGemName[5]..".")
		end
	end
	
	if button == "buff1" then
		GameTooltip:SetText(L["Armor"], 1, 1, 1, 1)
		if Cryolysis2.Private.HasFrostArmor and not Cryolysis2.Private.HasIceArmor then
			GameTooltip:AddLine(L["Left-click to cast "]..BS["Frost Armor"]..".")
		else
			GameTooltip:AddLine(L["Left-click to cast "]..BS["Ice Armor"]..".")
		end
		if Cryolysis2.Private.HasMoltenArmor then
			GameTooltip:AddLine(L["Middle-click to cast "]..BS["Molten Armor"]..".")
		end
		if Cryolysis2.Private.HasMageArmor then
			GameTooltip:AddLine(L["Right-click to cast "]..BS["Mage Armor"]..".")
		end
	end
	if button == "buff2" then
		GameTooltip:SetText(L["Intellect"], 1, 1, 1, 1)
		if Cryolysis2.Private.HasArcaneIntellect then
			GameTooltip:AddLine(L["Left-click to cast "]..BS["Arcane Intellect"]..".")
		end
		if Cryolysis2.Private.HasArcaneBrilliance then
			GameTooltip:AddLine(L["Right-click to cast "]..BS["Arcane Brilliance"]..".")
		end
	end
	if button == "buff3" then
		GameTooltip:SetText(L["Magic"], 1, 1, 1, 1)
		if Cryolysis2.Private.HasDampenMagic then
			GameTooltip:AddLine(L["Left-click to cast "]..BS["Dampen Magic"]..".")
		end
		if Cryolysis2.Private.HasAmplifyMagic then
			GameTooltip:AddLine(L["Right-click to cast "]..BS["Amplify Magic"]..".")
		end
	end
	if button == "buff4" then
		GameTooltip:SetText(L["Damage Shields"], 1, 1, 1, 1)
		if Cryolysis2.Private.HasIceBarrier then
			GameTooltip:AddLine(L["Left-click to cast "]..BS["Ice Barrier"]..".")
			GameTooltip:AddLine(L["Right-click to cast "]..BS["Mana Shield"]..".")
		else
			GameTooltip:AddLine(L["Left-click to cast "]..BS["Mana Shield"]..".")
		end
	end
	if button == "buff5" then
		GameTooltip:SetText(L["Magical Wards"], 1, 1, 1, 1)
		if Cryolysis2.Private.HasFireWard then
			GameTooltip:AddLine(L["Left-click to cast "]..BS["Fire Ward"]..".")
		end
		if Cryolysis2.Private.HasFrostWard then
			GameTooltip:AddLine(L["Right-click to cast "]..BS["Frost Ward"]..".")
		end
	end
	if button == "buff6" then
		GameTooltip:SetText(BS["Remove Lesser Curse"], 1, 1, 1, 1)
		GameTooltip:AddLine(L["Click to cast "]..BS["Remove Lesser Curse"]..".")
	end
	if button == "buff7" then
		GameTooltip:SetText(BS["Slow Fall"], 1, 1, 1, 1)
		GameTooltip:AddLine(L["Click to cast "]..BS["Slow Fall"]..".")
	end
	
	GameTooltip:Show()
end
